MODULE GameOfLife
	IMPLICIT NONE
	PRIVATE
	PUBLIC:: show, GameOfLifeStep, GoLCshift

CONTAINS

			!!! Aufgabe 1
	  FUNCTION GameOfLifeStep(Feld)
		    INTEGER,DIMENSION(:,:)::Feld
		    INTEGER,DIMENSION(SIZE(Feld,1),SIZE(Feld,2))::GameOfLifeStep
		    INTEGER:: i,j,m

				!!! Welche Zellen leben danach?
				!!! wir müssen für jede Zelle einzeln bestimmen, ob sie ALIVE ist
				!!! Rand bleibt gleich, d.h. Randpunkte sind keine Mittelpunkte der Teilfelder für ALIVE
				GameOfLifeStep = 0
				m = SIZE(Feld, 2)

				DO i = 2, SIZE(Feld, 1)-1!!! Zeilen
					DO j = 2, m-1!! Spalten
							!!! Ist Feldeintrag i,j ALIVE ?
							IF(ALIVE(Feld(i-1:i+1,j-1:j+1))) GameOfLifeStep(i,j) = 1
					END do
				END DO

	  END FUNCTION GameOfLifeStep

		!!! Aufgabe 2
    FUNCTION ALIVE(Feld)
	    INTEGER, DIMENSION(3,3)::Feld
	    LOGICAL:: ALIVE
			INTEGER:: s

			s = SUM(Feld)
			!!! Lebt die Zelle aktuell ?? Überleben / Austerben oder Wachtum
			IF(Feld(2,2)==1)THEN !!! Überlebt die Zelle?
				ALIVE = (s == 3.OR. s == 4)
			ELSE !!! Gibt es Wachtum?
				ALIVE = s == 3
			END IF

			!ALIVE = (Feld(2,2)==1.AND.(s == 3.OR.s == 4)).OR.(Feld(2,2)==0.AND.s == 3)
			!!! verbesserungswürdig
    END FUNCTION ALIVE

		!!! Zusatzaufgabe 5
    FUNCTION ALIVE2(Feld,B,S)
	    INTEGER, DIMENSION(3,3)::Feld
      INTEGER, DIMENSION(:) :: B, S
	    LOGICAL:: ALIVE2
	    INTEGER::summe, i

	    summe=SUM(Feld)
	    IF (Feld(2,2)==1) THEN
        ALIVE2 = ANY(S == summe)
	    ELSE
		    ALIVE2 = ANY(B == summe)
	    END IF
    END FUNCTION ALIVE2

		!!! Zusatzaufgabe 6
    FUNCTION GoLCshift(Feld)
        INTEGER,DIMENSION(:,:):: Feld
        INTEGER,DIMENSION(SIZE(Feld,1),SIZE(Feld,2)):: GoLCshift,Neighs
        INTEGER:: i,j

        Neighs=0
        GoLCshift=0
        DO i=-1,1
            DO j=-1,1
                IF (i==0 .AND. j==0) CYCLE
                Neighs=Neighs+Cshift(Cshift(Feld,i,1),j,2)
            END DO
        END DO
        WHERE (Neighs==3 .OR. (Feld==1 .AND. Neighs==2))
            GoLCshift=1
        END WHERE
    END FUNCTION GoLCshift

		!!! Aufgabe 3
    SUBROUTINE show(Feld)
	    INTEGER,DIMENSION(:,:)::Feld
	    INTEGER::i,j,n


			!!! "zwei" ineinander geschachtelte Do-Schleifen

			!!! Für jede Zeile, erzeuge horizontale Trennlinie        +---+---+
			!!! und zusätzlich wechselt sich das ab mit den Einträgen |   | 0 | ....
			n = SIZE(Feld,2)
			DO i = 2, SIZE(Feld, 1) !!! Für jede Zeile
				!!! horizontale Trennlinie
				DO j=2,n-1 !!! Für jede Spalte
					WRITE(*,'(A)',ADVANCE='NO') '+---'
				END DO
				WRITE(*,'(A)',ADVANCE='YES') '+'  !!! Abschluss der Zeile

				DO j=2,n-1

			    IF (Feld(i,j)==1) THEN
				    WRITE(*,'(A)',ADVANCE='NO') '| O '
			    ELSE
				    WRITE(*,'(A)',ADVANCE='NO') '|   '
			    END IF

		    END DO

		    WRITE(*,'(A)',ADVANCE='YES') '|' !!! Abschluss der Zeile
			END DO

			!!! Die Abschlusszeile, die abschließende Zeile
			DO j=2,n-1
					WRITE(*,'(A)',ADVANCE='NO') '+---'
			END DO
			WRITE(*,'(A)',ADVANCE='YES')'+'
			WRITE(*,*)

    END SUBROUTINE show

END MODULE GameOfLife

PROGRAM TEST
	USE GameOfLife, ONLY: show, GameOfLifeStep, GoLCshift
	IMPLICIT NONE

	INTEGER,DIMENSION(0:7,0:7):: Feld,Feld2
	INTEGER:: i

	!!! Initialisieren
	Feld=0
	Feld(4,2:4)=1
	Feld(3,4)=1
	Feld(3,3)=1
	Feld(2,2 )=1
	Feld(5,5)=1

  Feld2 = Feld

	!!! Simulation mit Variante aus Aufgabe 1
	CALL show(Feld)
	DO i=1,4
		Feld=GameOfLifeStep(Feld)
		Call show(Feld)
		READ(*,*) !!! Programm pausiert
	END DO

	!!! Simulation mit Variante aus Zusatzaufgabe 6
  WRITE(*,*) '2.Feld'
  CALL show(Feld2)
  DO i=1,4
      Feld2=GoLCshift(Feld2)
      CALL show(Feld2)
			READ(*,*)
  END DO
END PROGRAM TEST
