module contmod
    implicit none
    private
    public:: operator(<),content, name, datum

    type name
        character(15)::nname,vname
    end type

    type datum
        integer::d,m,y
    end type

    type content
        type(name)::nam
        type(datum)::dat
    end type

    interface operator (<)
        module procedure klnam,kldat
    end interface

contains

    logical function klnam(a,b)
        type(name),intent(in)::a,b

        klnam=a%nname<b%nname
        if(a%nname==b%nname)then
            klnam=a%vname<b%vname
        end if
    end function

    logical function kldat(a,b)
        type(datum),intent(in)::a,b
        !kldat=a%y<b%y.or.a%y=b%y.and.(a%m<b%m.or.a%m=b%m.and.a%d<b%d)
        kldat=a%y<b%y
        if(a%y==b%y)then
            kldat=a%m<b%m
            if(a%m==b%m)then
                kldat=a%d<b%d
            end if
        end if
    end function

end module

MODULE Sortierverfahren
	USE contmod
	IMPLICIT NONE
	PRIVATE
	PUBLIC:: QuicksortName, QuicksortDate, content, name, datum

CONTAINS

RECURSIVE SUBROUTINE QuicksortName(Feld,counter)
    TYPE(content),DIMENSION(1:) :: Feld
    INTEGER:: i,j,counter,a,b,n
		TYPE(content):: pivot, swap

    !!! Feldlaenge speichern
    !!! Pivotelement festlegen - hier das Element "in der Mitte"
    !!! man kann auch das erste oder letzte Element wählen, sinnvoll: Pivotelement zufaellig waehlen
    !!! Initialisieren

    n=SIZE(Feld)
    i=1 !!! von links
    j=n !!! von rechts
    pivot=Feld(n/2) !!! Pivotelement waehlen
    counter=4

    !!! DO-Schleife
      !!! von links Element suchen, dass groesser als Pivotelement
      !!! denn es muss ja an der falschen Stelle sein

      !!! von rechts Element suchen, dass kleiner als Pivotelement

      !!! Elemente tauschen, wenn i<=j
      !!! sonst Schleife verlassen, da Teilfelder korrekt erstellt, d.h. ein Teilfeld
      !!! mit kleineren und ein mit groesseren Elementen als das Pivotelement
    !!! END DO

    !!! rekursiver Aufruf auf Teilfelder, aber nur wenn "echte Felder" vorliegen
    !!! d.h. 1 < j und / oder n > i
    !!! Abbruch der Rekursion, wenn nur noch einelementige Teilfelder
    !!! counter erhöhen


    DO
        DO WHILE(Feld(i)%nam < pivot%nam)
            i=i+1
            counter=counter+2
        END DO

        counter=counter+1
        DO WHILE(pivot%nam < Feld(j)%nam)
            j=j-1
            counter=counter+2
        END DO
        counter=counter+1

        IF (i<=j) THEN
            swap=Feld(i)
            Feld(i)=Feld(j)
            Feld(j)=swap
            i=i+1
            j=j-1
            counter=counter+6
            IF(i>j) EXIT
        ELSE
            counter=counter+1
            EXIT
        END IF

    END DO

    a=0
    b=0
    IF (1<j) THEN
        CALL QuicksortName(Feld(1:j),a)
    END IF
    IF (n>i) THEN
        CALL QuicksortName(Feld(i:n),b)
    END IF
    counter=counter+a+b
END SUBROUTINE

RECURSIVE SUBROUTINE QuicksortDate(Feld,counter)
    TYPE(content),DIMENSION(1:) :: Feld
    INTEGER:: i,j,counter,a,b,n
		TYPE(content):: pivot, swap

    n=SIZE(Feld)
    i=1
    j=n
    pivot=Feld(n/2)
    counter=4
    DO
        DO WHILE (Feld(i)%dat < pivot%dat )
            i=i+1
            counter=counter+2
        END DO
        counter=counter+1
        DO WHILE(pivot%dat < Feld(j)%dat)
            j=j-1
            counter=counter+2
        END DO
        counter=counter+1
        IF (i<=j) THEN
            swap=Feld(i)
            Feld(i)=Feld(j)
            Feld(j)=swap
            i=i+1
            j=j-1
            counter=counter+6
            IF(i>j) EXIT
        ELSE
            counter=counter+1
            EXIT
        END IF
    END DO
    a=0
    b=0
    IF (1<j) THEN
        CALL QuicksortDate(Feld(1:j),a)
    END IF
    IF (n>i) THEN
        CALL QuicksortDate(Feld(i:n),b)
    END IF
    counter=counter+a+b
END SUBROUTINE


END MODULE

PROGRAM TestSort
	USE Sortierverfahren
	IMPLICIT NONE

	TYPE(content),DIMENSION(3):: studenten, sorted
	INTEGER:: steps

	studenten(1) = content(name("Max","Mustermann"), datum(1,4,1985))
	studenten(2) = content(name("Marta","Mustermann"), datum(12,3,1990))
	studenten(3) = content(name("Anna","Mayer"), datum(1,5,1985))

  sorted = studenten

	WRITE(*,*) "unsortiert", studenten(:)%nam
  WRITE(*,*) studenten(:)%dat
  WRITE(*,*)


  steps = 0
	CALL QuicksortName(sorted, steps)

	WRITE(*,*) "sortiert nach Namen:", sorted(:)%nam
  WRITE(*,*) sorted(:)%dat
  WRITE(*,*)
	WRITE(*,*) "Anzahl der Schritte:", steps

  sorted = studenten

  steps = 0
  CALL QuicksortDate(sorted, steps)

  WRITE(*,*) "sortiert nach Alter:", sorted(:)%nam
  WRITE(*,*) sorted(:)%dat
  WRITE(*,*)
  WRITE(*,*) "Anzahl der Schritte:", steps
END PROGRAM


"
3 5 2 1 4
i   P   j

3 5 2 1 4
i   P j
*

3 5 2 1 4
i   P j
*     *

    P
1 5 2 3 4
  i j
  * *

  P
1 2 5 3 4
  j i

ABBRUCH der Schleife
und rekursiver Aufruf auf Teilfelder

1 P 5 3 4
-   --Q--

.....

  P
1 2 3 4 5

"
