MODULE mat_mod
  IMPLICIT NONE

CONTAINS

  SUBROUTINE get (M)
    INTEGER, DIMENSION(:,:), INTENT(INOUT) :: M
    INTEGER :: i

    DO i = 1, SIZE(M, 1)
      WRITE(*,'(A, I2, A)') 'Bitte Zeile ', i, ' eingeben. '
      READ(*,*) M(i, :)
    END DO
  END SUBROUTINE

  FUNCTION trace (M)
    INTEGER, DIMENSION(:,:), INTENT(IN) :: M
    INTEGER :: trace, k
 
    trace = SUM( (/ ( M(k,k), k = 1, MIN(SIZE(M,1), SIZE(M,2)) ) /) )
  END FUNCTION

  FUNCTION ortho (M)
    INTEGER, DIMENSION(:,:), INTENT(IN) :: M
    INTEGER, DIMENSION(SIZE(M,1), SIZE(M,2)) :: N, I
    LOGICAL :: ortho
    INTEGER :: k

    I = 0
    DO k=1, SIZE(I,1)
      I(k,k) = 1
    END DO

    N = MATMUL(M, TRANSPOSE(M))
    ortho = ALL(N == I)
  END FUNCTION

  FUNCTION pos (M)
    INTEGER, DIMENSION(:,:), INTENT(IN) :: M
    INTEGER, DIMENSION(SIZE(M,1),SIZE(M,2)) :: pos

    pos = max(M, 0)
  END FUNCTION

END MODULE

PROGRAM mat
  USE mat_mod
  IMPLICIT NONE

  INTEGER, DIMENSION(:,:), ALLOCATABLE :: M, N
  INTEGER :: dimen, i

  WRITE(*,*) 'Bitte die Dimension der Matrix eingeben. '
  READ(*,*) dimen
  ALLOCATE(M(dimen,dimen), N(dimen,dimen))
  M = 0
  N = 0

  CALL get(M)

  WRITE(*,*)
  WRITE(*,*) 'Die Spur der Matrix betraegt ', trace(M)
  IF (ortho(M)) THEN
    WRITE(*,*) 'Die Matrix ist orthogonal. '
  ELSE
    WRITE(*,*) 'Die Matrix ist nicht orthogonal. '
  END IF

  WRITE(*,*)
  WRITE(*,*) 'Positivteil: '
  N = pos(M)
  DO i = 1, SIZE(N, 1)
    WRITE(*,*) N(i, :)
  END DO

END PROGRAM
