MODULE adt_student
  IMPLICIT NONE
  PRIVATE
  PUBLIC:: PUT, highersem, names, GET, student
  
  TYPE student
     CHARACTER(LEN=30):: vorname, nachname
     INTEGER:: age, semester
  END TYPE student

CONTAINS

  FUNCTION GET(vname, nname, alter, sem)
    TYPE(student):: GET
    CHARACTER(LEN=30):: vname, nname
    INTEGER:: alter, sem
  
    GET%vorname = vname
    GET%nachname = nname
    GET%age = alter
    GET%semester = sem
  END FUNCTION GET

  SUBROUTINE PUT(a)
    TYPE(student), INTENT(IN):: a
    WRITE(*,*) TRIM(a%vorname),' ', TRIM(a%nachname),',', a%age, 'Jahre, ist Student im', a%semester,'. Semester.'
  END SUBROUTINE PUT

  FUNCTION highersem(a,b)
    TYPE(student), INTENT(IN):: a, b
    LOGICAL:: highersem
    highersem = a%semester > b%semester
  END FUNCTION

  FUNCTION names(a,b)
    TYPE(student), INTENT(IN):: a, b
    LOGICAL:: names
    
    IF(a%nachname == b%nachname) THEN
      names = a%vorname > b%vorname
    ELSE
      names = a%nachname > b%nachname
    END IF
  END FUNCTION

END MODULE adt_student

PROGRAM adt
  USE adt_student, ONLY: PUT, highersem, names
  IMPLICIT NONE
  
  CHARACTER(LEN=30):: vname, nname
  INTEGER:: alter, sem
  TYPE(student):: person1, person2
  
  WRITE(*,*) 'Please enter name, family name, age and semester of the first person.'
  READ(*,*) vname, nname, alter, sem
  person1 = GET(vname, nname, alter, sem)
  
  WRITE(*,*) 'Please enter name, family name, age and semester of the second person.'
  READ(*,*) vname, nname, alter, sem
  person2 = GET(vname, nname, alter, sem)

  WRITE(*,*) TRIM(person1%vorname),'', TRIM(person1%nachname), ' is in a higher semester:', highersem(person1, person2)
  WRITE(*,*) 'Person1 has a name lexically later in the dictionary:', names(person1, person2)
  CALL PUT(person1)
  CALL PUT(person2)
END PROGRAM adt
